<template>
  <div>
    <h1 class="text-2xl text-purple-600">{{ title }}</h1>
    <table class="table-auto border-separate border border-green-800">
      <tr
        class="
          text-md
          font-semibold
          tracking-wide
          text-left text-gray-900
          bg-gray-100
          uppercase
          border-b border-gray-600
        "
      >
        <th>Nombre de sucursal</th>
        <th>Horario</th>
        <th>Dirección completa</th>
        <th>N° de usuarios</th>
      </tr>
      <tr
        v-for="location in locationList"
        :key="location.id"
        class="text-gray-700"
      >
        <td class="px-4 py-3 border">
          {{ location.name }}
        </td>
        <td class="px-4 py-3 border">
          {{ location.startTime }} - {{ location.endTime }}
        </td>
        <td class="px-4 py-3 border">
          {{ location.address1 }}, {{ location.address2 }},
          {{ location.comuna }},
          {{ location.region }}
        </td>
        <td class="px-4 py-3 border">{{ location.counter }}</td>
      </tr>
    </table>
    <ul v-if="errors && errors.length">
      <li v-for="error of errors" :key="error.message">
        {{ error.message }}
      </li>
    </ul>
  </div>
</template>

<script>
import getUsers from '../helpers/getUsers.js';
import getLocations from '../helpers/getLocations.js';

export default {
  data() {
    return {
      title: 'Sucursales',
      locationList: [],
      errors: [],
    };
  },
  async created() {
    try {
      this.usersList = await getUsers();
      this.locationList = await getLocations();
      this.locationList.sort(function (a, b) {
        if (a.name > b.name) {
          return 1;
        }
        if (a.name < b.name) {
          return -1;
        }
        return 0;
      });
      const userList = this.usersList;
      this.locationList.forEach(async function (location) {
        location.counter = 0;
        userList.forEach(function (user) {
          if (user.locationId.includes(location.id)) {
            location.counter += 1;
          }
        });
      });
    } catch (e) {
      this.errors.push(e);
    }
  },
};
</script>
